SystemOrganization addCategory: #'PBE-LightsOut'!

SimpleSwitchMorph subclass: #LOCell
	instanceVariableNames: 'mouseAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PBE-LightsOut'!

!LOCell commentStamp: 'DanielWu 3/26/2017 22:16' prior: 0!
LightsOutCell which can toggle between Yellow and Blue.!

!LOCell methodsFor: 'initialization' stamp: 'DanielWu 3/27/2017 01:08'!
initialize
	super initialize.
	self label: ''.
	self borderWidth: 2.
	bounds := 0 @ 0 corner: 16 @ 16.
	offColor := Color paleYellow.
	onColor := Color paleBlue darker.
	self useSquareCorners.
	self turnOff! !

!LOCell methodsFor: 'accessing' stamp: 'DanielWu 3/27/2017 00:32'!
mouseAction: aBlock
	^ mouseAction := aBlock! !

!LOCell methodsFor: 'accessing' stamp: 'DanielWu 3/27/2017 01:15'!
mouseMove: anEvent
! !

!LOCell methodsFor: 'accessing' stamp: 'DanielWu 3/27/2017 00:48'!
mouseUp: anEvent
	mouseAction value! !

BorderedMorph subclass: #LOGame
	instanceVariableNames: 'cells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PBE-LightsOut'!

!LOGame methodsFor: 'accessing' stamp: 'DanielWu 3/27/2017 00:39'!
cellsPerSide
	"Always return 10 cells for width or height. Should belong to class side."
	
	^ 10! !

!LOGame methodsFor: 'initialization' stamp: 'DanielWu 3/27/2017 00:25'!
initialize
	| sampleCell width height n |
	super initialize.
	n := self cellsPerSide.
	sampleCell := LOCell new.
	width := sampleCell width.
	height := sampleCell height.
	self bounds: (5 @ 5 extent: (width * n) @ (height * n) + (2 * self borderWidth)).
	cells := Matrix new: n tabulate: [ :i :j | self newCellAt: i at: j ]! !

!LOGame methodsFor: 'initialization' stamp: 'DanielWu 3/27/2017 01:03'!
newCellAt: i at: j
	"Create cell at position (i,j) and add it to on-screen representation at
		the appropriate screen position, adding callback which toggles state of
		neighboring cells."
	| c origin |
	c := LOCell new.
	origin := self innerBounds origin.
	self addMorph: c.
	
	c position: ((i-1) * c width) @ ((j-1) * c height) + origin.
	c mouseAction: [ self toggleNeighborsOfCellAt: i at: j ].
	^ c! !

!LOGame methodsFor: 'game logic' stamp: 'DanielWu 3/27/2017 00:59'!
toggleNeighborsOfCellAt: i at: j
	1 < i
		ifTrue: [ (cells at: i-1 at: j) toggleState ].		"Left neighbor"
	i < self cellsPerSide
		ifTrue: [ (cells at: i+1 at: j) toggleState ].		"Right neighbor"
	1 < j
		ifTrue: [ (cells at: i at: j-1) toggleState ].		"Upper neighbor"
	j < self cellsPerSide
		ifTrue: [ (cells at: i at: j+1) toggleState ].		"Lower neighbor"! !
